VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.1#0"; "COMCTL32.OCX"
Begin VB.Form frm_Main 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "TrayIcon Demo Program"
   ClientHeight    =   3615
   ClientLeft      =   3150
   ClientTop       =   2820
   ClientWidth     =   4920
   Icon            =   "main.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3615
   ScaleWidth      =   4920
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'None
      Height          =   2610
      Left            =   120
      ScaleHeight     =   2610
      ScaleWidth      =   4680
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   405
      Width           =   4680
      Begin VB.TextBox Text1 
         Height          =   285
         Left            =   135
         TabIndex        =   6
         Text            =   "Tray Notification Demo"
         Top             =   1830
         Width           =   2805
      End
      Begin MSComDlg.CommonDialog cDialog 
         Left            =   3975
         Top             =   1320
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   327680
      End
      Begin VB.Frame Frame1 
         Caption         =   "Choose Icon"
         Height          =   1020
         Left            =   135
         TabIndex        =   2
         Top             =   105
         Width           =   4380
         Begin VB.CommandButton cmdChoose 
            Caption         =   "Browse..."
            Height          =   375
            Left            =   1125
            TabIndex        =   3
            Top             =   390
            Width           =   930
         End
         Begin VB.Image Image2 
            BorderStyle     =   1  'Fixed Single
            Height          =   540
            Left            =   2610
            Picture         =   "main.frx":000C
            Top             =   315
            Visible         =   0   'False
            Width           =   540
         End
         Begin VB.Image Image1 
            BorderStyle     =   1  'Fixed Single
            Height          =   540
            Left            =   285
            Picture         =   "main.frx":044E
            Top             =   330
            Width           =   540
         End
      End
      Begin VB.CheckBox Check1 
         Caption         =   "&Flash Icon in Tray"
         Height          =   210
         Left            =   165
         TabIndex        =   4
         Top             =   1215
         Width           =   2295
      End
      Begin VB.Timer Timer1 
         Enabled         =   0   'False
         Interval        =   750
         Left            =   3510
         Top             =   1350
      End
      Begin VB.Label Label1 
         Caption         =   "&Tooltip Text:"
         Height          =   210
         Left            =   180
         TabIndex        =   5
         Top             =   1605
         Width           =   1215
      End
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3810
      TabIndex        =   10
      Top             =   3135
      Width           =   1020
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2715
      TabIndex        =   9
      Top             =   3135
      Width           =   1020
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   1620
      TabIndex        =   8
      Top             =   3135
      Width           =   1020
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit Program"
      Height          =   375
      Left            =   90
      TabIndex        =   7
      Top             =   3135
      Width           =   1080
   End
   Begin ComctlLib.TabStrip TabStrip1 
      Height          =   2970
      Left            =   90
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   75
      Width           =   4740
      _ExtentX        =   8361
      _ExtentY        =   5239
      _Version        =   327680
      BeginProperty Tabs {0713E432-850A-101B-AFC0-4210102A8DA7} 
         NumTabs         =   1
         BeginProperty Tab1 {0713F341-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "General"
            Object.Tag             =   ""
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frm_Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private sToolTip As String
Private picImage As Picture
'

Private Sub Check1_Click()

    cmdApply.Enabled = True

End Sub

Private Sub cmdCancel_Click()

    Me.Hide

End Sub

Private Sub cmdChoose_Click()

    On Error Resume Next
    
    With cDialog
        .Filter = "Icon Files (*.ico)|*.ico|All Files|*.*"
        .Flags = cdlOFNExplorer Or cdlOFNLongNames
        .CancelError = True
        .ShowOpen
        
        If Err = cdlCancel Then Exit Sub
        If Err = 0 Then ChangeIcon .filename
    End With

End Sub

Private Sub ChangeIcon(sName As String)

    Dim Img As Picture
    
    Set Img = LoadPicture(sName)
    
    If Err > 0 Then
        MsgBox "Invalid image file format.  Cannot load image.", vbInformation, "Tray Demo"
        Err = 0
    Else
        Image1.Picture = Img
        cmdApply.Enabled = True
    End If

End Sub

Private Sub cmdExit_Click()

    Unload Me

End Sub

Private Sub cmdOK_Click()

    cmdApply_Click
    Me.Hide

End Sub

Private Sub cmdApply_Click()

    Dim iconNotify As NOTIFYICONDATA
    Dim rVal As Long
    
    With iconNotify
        .cbSize = Len(iconNotify)
        .hwnd = Me.hwnd
        .uID = 1
        .uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
        .uCallbackMessage = WM_LBUTTONDOWN
        .hIcon = Image1.Picture
        .szTip = Trim$(Text1) & Chr$(0)
    End With
    
    rVal = Shell_NotifyIcon(NIM_MODIFY, iconNotify)
    
    Set picImage = Image1.Picture
    sToolTip = Trim$(Text1)
    Timer1.Enabled = (Check1 = vbChecked)
    frm_Menu.mnPopup(1).Checked = (Check1 = vbChecked)
    
    cmdApply.Enabled = False

End Sub

Private Sub Form_Load()

    Dim iconNotify As NOTIFYICONDATA
    Dim rVal As Long
    
    sToolTip = "Tray Notification Demo"
    Set picImage = Image1.Picture
    
    ghWnd = Me.hwnd
    HookWindow
    
    With iconNotify
        .cbSize = Len(iconNotify)
        .hwnd = Me.hwnd
        .uID = 1
        .uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
        .uCallbackMessage = WM_LBUTTONDOWN
        .hIcon = Image1.Picture
        .szTip = sToolTip & Chr$(0)
    End With
    
    rVal = Shell_NotifyIcon(NIM_ADD, iconNotify)
    Me.Hide

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Dim iconNotify As NOTIFYICONDATA
    Dim rVal As Long
        
    Unload frm_Menu
    Set frm_Menu = Nothing
    
    With iconNotify
        .cbSize = Len(iconNotify)
        .hwnd = Me.hwnd
        .uID = 1
    End With
    
    rVal = Shell_NotifyIcon(NIM_DELETE, iconNotify)
    
    UnhookWindow
    
End Sub

Public Sub ShowForm()

    Image1.Picture = picImage
    Text1 = sToolTip
    
    If frm_Menu.mnPopup(1).Checked Then
        Check1 = vbChecked
    Else
        Check1 = vbUnchecked
    End If

    Me.Show vbModeless

End Sub

Private Sub Text1_Change()

    cmdApply.Enabled = True

End Sub

Private Sub Text1_GotFocus()

    With Text1
        .SelStart = 0
        .SelLength = Len(.Text)
    End With

End Sub

Private Sub Timer1_Timer()
        
    Dim rVal As Long
    Dim iconNotify As NOTIFYICONDATA
    
    With iconNotify
        .cbSize = Len(iconNotify)
        .hwnd = Me.hwnd
        .uID = 1
        .uFlags = NIF_ICON
    
        If bFlashState Then
            .hIcon = Image1.Picture
        Else
            .hIcon = Image2.Picture
        End If
        
        bFlashState = Not bFlashState
        rVal = Shell_NotifyIcon(NIM_MODIFY, iconNotify)
    End With
    
End Sub

